--- mainwindow.py.orig	2010-12-29 04:44:29.000000000 +0100
+++ mainwindow.py	2010-12-30 22:20:56.286146091 +0100
@@ -155,7 +155,7 @@ class MainWindow(QtGui.QGraphicsView):
                     # 0, 520,
                     0, 0])
 
-            self.setMask(QtCore.QRegion(region))
+            self.setMask(QtGui.QRegion(region))
 
     def setupScene(self):
         self.scene = DemoScene(self)
@@ -327,8 +327,7 @@ class MainWindow(QtGui.QGraphicsView):
 
     def keyPressEvent(self, event):
         if event.key() == QtCore.Qt.Key_Escape:
-            self.loop = False
-            QtGui.QApplication.quit()
+            self.quit()
         elif event.key() == QtCore.Qt.Key_F1:
             s = ""
             s += "Rendering system: "
@@ -416,3 +415,11 @@ class MainWindow(QtGui.QGraphicsView):
         # Changing size will almost always hurt FPS during the change so ignore
         # it.
         self.fpsHistory = []
+
+    def closeEvent(self, event):
+        self.quit()
+
+    def quit(self):
+        self.loop = False
+        import sys
+        sys.exit(0)
--- menumanager.py.orig	2010-12-29 04:44:29.000000000 +0100
+++ menumanager.py	2010-12-30 22:20:26.804950382 +0100
@@ -156,8 +156,7 @@ class MenuManager(QtCore.QObject):
         elif userCode == MenuManager.DOCUMENTATION:
             self.showDocInAssistant(self.currentInfo)
         elif userCode == MenuManager.QUIT:
-            self.window.loop = False
-            QtCore.QCoreApplication.quit()
+            self.window.quit()
         elif userCode == MenuManager.FULLSCREEN:
             self.window.toggleFullscreen()
         elif userCode == MenuManager.ROOT:
